# frozen_string_literal: true

require 'json'
require 'yaml'
require 'net/http'

AUTOMATION_NOTE_TITLE = '# Priorities Automation'
GENERATED_BY_FOOTER = '_Generated by :factory: [Priorities Refinement Automation](https://gitlab.com/gitlab-org/security-risk-management/security-policies/projects/priorities-refinement) (**v1.0.1**)_'
FILE_NAME = 'note.md'
DEFAULT_PRIORITIES_TO_PROCESS = 15

def fetch_priorities
  data = YAML.safe_load(Net::HTTP.get(URI(ENV['PRIORITIES_URL'])))
  puts "Processing first #{priorities_to_process} priorities..."
  data['priorities'].first(priorities_to_process).each.with_index do |priority, index|
    puts "##{index + 1}/#{priorities_to_process}: Checking Priority '#{priority['name']}'..."
    check_priority(index, priority)
    puts "...processing finished.\n\n"
  end
rescue StandardError => e
  puts "Error in #fetch_priorities [#{e.class}: #{e.message}]"
  {}
end

def priorities_to_process
  return DEFAULT_PRIORITIES_TO_PROCESS if ENV['PRIORITIES_TO_PROCESS'].nil?

  ENV['PRIORITIES_TO_PROCESS'].to_i
end

def check_priority(index, priority)
  data = fetch_details_about_priority(priority['url'])
  puts 'Unable to process priority, no data.' && return if data.nil? || data.empty?

  workflow_label = data['labels'].to_a.find { |label| label.start_with?('workflow::') }
  note_thread = data['notes'].find { |note| note['body'].start_with?(AUTOMATION_NOTE_TITLE) }

  puts "Processing priority with #{workflow_label || 'no valid'} label"

  new_note = case workflow_label
             when 'workflow::refinement'         then ready_for_refinement_note(priority['be_dri'], priority['fe_dri'],
                                                                                data['type'], 'refined')
             when 'workflow::planning breakdown' then ready_for_refinement_note(priority['be_dri'], priority['fe_dri'],
                                                                                data['type'], 'broken down')
             when nil                            then no_workflow_label_note(data['type'])
             end

  puts 'No action needed.' && return if new_note.nil?

  if note_thread.nil?
    create_note("#{data['notes_api_base_url']}/notes", "#{AUTOMATION_NOTE_TITLE}\n#{new_note}")
  else
    create_note("#{data['notes_api_base_url']}/discussions/#{note_thread['id']}/notes", new_note)
  end
end

def fetch_details_about_priority(url)
  case url
  when %r{gitlab-org/gitlab/-/issues/(\d+)}
    fetch_api("projects/278964/issues/#{Regexp.last_match(1)}")
      .merge(
        'notes_api_base_url' => "projects/278964/issues/#{Regexp.last_match(1)}",
        'notes' => fetch_api("projects/278964/issues/#{Regexp.last_match(1)}/notes").to_a,
        'type' => 'Issue'
      )
  when %r{groups/gitlab-org/-/epics/(\d+)}
    fetch_api("groups/9970/epics/#{Regexp.last_match(1)}")
      .then do |result|
        result
          .merge(
            'notes_api_base_url' => "groups/9970/epics/#{result['id']}",
            'notes' => fetch_api("groups/9970/epics/#{result['id']}/notes").to_a,
            'type' => 'Epic'
          )
      end
  end
end

def fetch_api(query)
  raw = `glab api #{query}`
  JSON.parse(raw)
rescue StandardError => e
  puts "Error in #fetch_api [#{e.class}: #{e.message}]"
  {}
end

def create_note(url, note)
  if ENV['DRY_RUN']
    puts 'dry-run option selected, no note will be created'
    puts "Create Note:\n\n#{note}"
    puts "glab api #{url} -X POST -F body=@#{FILE_NAME}"
  else
    File.open(FILE_NAME, 'w+') { |f| f.write(note) }
    `glab api #{url} -X POST -F body=@#{FILE_NAME}`
    puts 'Note created.'
  end
end

def ready_for_refinement_note(be_dri, fe_dri, type, action)
  handle = ''
  handle += "@#{be_dri}" if !be_dri.nil? && !be_dri.empty?
  handle += " @#{fe_dri}" if !fe_dri.nil? && !fe_dri.empty?

  if handle.empty?
    <<~MARKDOWN
      #{ENV['EM_HANDLE']}, it looks like this #{type} is ready to be #{action}, but has no DRIs assigned. Would you mind taking a look? :eyes:

      #{GENERATED_BY_FOOTER}
    MARKDOWN
  else
    <<~MARKDOWN
      #{handle}, it looks like this #{type} is ready to be #{action}. Would you mind taking a look? :eyes:

      You can use [Epic Engineering DRI](https://about.gitlab.com/handbook/engineering/development/sec/govern/sp-ti-planning.html#epic-engineering-dri) as a guideline what to do in this step.
      If this step is finished for both ~frontend and ~backend, assign ~"workflow::ready for development" to avoid receiving this message in the future. :bow:

      /cc #{ENV['EM_HANDLE']}

      #{GENERATED_BY_FOOTER}
    MARKDOWN
  end
end

def no_workflow_label_note(type)
  <<~MARKDOWN
    #{ENV['PM_HANDLE']}, it looks like we are missing `~workflow::` label for this #{type}. Would you mind taking a look? :eyes:

    /cc #{ENV['EM_HANDLE']}

    #{GENERATED_BY_FOOTER}
  MARKDOWN
end

fetch_priorities
